#!/bin/tcsh -f
#

set path=( /bin /usr/bin /sbin /usr/sbin /usr/local/bin /usr/etc /etc )
 
echo " "

set count=`ps uxww | grep -v grep | grep -c XDarwin`
set count=0
if( $count != 0 ) then
  echo "XDarwin is currently running -"
  echo "please exit it before using this script"
  sleep 1
  exit 12
endif

set thisdir=`echo $0 | sed 's/UninterleaveX11.command//'`

if( ! -d "$thisdir" ) then
  echo "Could not find OroborOSX's directory"
  echo "  -assuming run from command line...?"
  sleep 1
else
  cd $thisdir
endif

if( ! -d /Applications ) then
  echo "The Applications directory is missing"
  echo " -aborting attempt to reset XDarwin"
  sleep 1
  exit 10
endif

if( ! -d /Applications/XDarwin.app ) then
  echo "Cannot find the XDarwin application"
  echo " -aborting attempt to reset XDarwin"
  sleep 1
  exit 2
endif

if( ! -f /Applications/XDarwin.app/Contents/Info.plist ) then
  echo "Cannot find XDarwin's Info.plist file"
  echo " -aborting attempt to reset XDarwin"
  sleep 1
  exit 3
endif

set count=`grep -i -c nsuielement /Applications/XDarwin.app/Contents/Info.plist`

if( $count == 0 ) then
  echo "XDarwin looks like it is already"
  echo "prevented from interleaving"
  echo " -no need to do anything"
  sleep 1
  exit
endif

if( ! -e /Applications/XDarwin.app/Contents/Info-org.plist ) then
  echo "Can't find XDarwin's original Info.plist"
  echo " -aborting attempt to reset XDarwin"
  sleep 1
  exit 4
endif

sudo -k
if( $#argv == 0 ) then
  echo "In order to reset XDarwin"
  echo "to stop window interleaving,"
  echo "I need Administrator access."
  echo " "
  echo "Type your password and press return"
  sudo mv /Applications/XDarwin.app/Contents/Info-org.plist /Applications/XDarwin.app/Contents/Info.plist
else
  echo $1 | sudo -p "" -S mv /Applications/XDarwin.app/Contents/Info-org.plist /Applications/XDarwin.app/Contents/Info.plist 
endif

echo " "

if( -f /Applications/XDarwin.app/Contents/Info-org.plist ) then
   echo "Failed to move back original Info.plist."
   echo "Maybe you do not have Administrator"
   echo "privileges, or perhaps you typed the"
   echo "password incorrectly?"
   sleep 1
   exit 5
endif

if( ! -f /Applications/XDarwin.app/Contents/Info.plist ) then
   echo "Failed to find moved Info.plist,"
   echo "yet the original has gone...???"
   echo "Please e-mail adrian@ic.ac.uk"
   echo "and report this error message."
   sleep 1
   exit 6
endif

set count=`grep -i -c nsuielement /Applications/XDarwin.app/Contents/Info.plist`

if( $count != 0 ) then
  echo "Something went wrong"
  echo " -failed to reset XDarwin's Info.plist"
  echo "Please e-mail adrian@ic.ac.uk"
  echo "and report this error message."
  sleep 1
  exit 7
endif

echo "XDarwin successfully reset"
echo " -window interleaving now disabled"
sleep 1

